%{
/*
 * IBM Dynamic Probes
 * Copyright (c) International Business Machines Corp., 2000
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

#include <stdio.h>
#include <string.h>
#include <linux/dprobes_in.h>
#include "../main.h"
#include "rpn.tab.h"
extern char * strip_quotes(char * str);
%}

%option noyywrap

%%
name		{ return NAME; }
vars		{ return VARS; }
gvars		{ return GVARS; }
major		{ return MAJOR; }
id		{ return ID; }
logmax		{ return LOGMAX; }
jmpmax		{ return JMPMAX; }
typedef		{ return TYPEDEF; }
groupdef	{ return GROUPDEF; }
modtype		{ return MODTYPE; }
user		{ return USER; }
kernel		{ return KERNEL; }
kmod		{ return KMOD; }
logonfault	{ return LOGONFAULT; }
yes		{ return YES; }
no 		{ return NO; }

minor		{ return MINOR; }
address		{ return ADDRESS; }
offset		{ return OFFSET; }
opcode		{ return OPCODE; }
pass_count	{ return PASSCOUNT;}
ignore		{ return PASSCOUNT;}
max_hits	{ return MAXHITS;}
maxhits		{ return MAXHITS;}
type		{ return TYPE; }
group 		{ return GROUP; }
watchpoint	{ return WATCHPOINT; }
x		{ return X; }
rw		{ return RW; }
io		{ return IO; }

seg2lin		{ return SEG2LIN; }

jmp		{ return JMP; }
jlt		{ return JLT; }
jle		{ return JLE; }
jgt		{ return JGT; }
jge		{ return JGE; }
jz		{ return JZ; }
jnz		{ return JNZ; }
loop		{ return LOOP; }
call		{ return CALL; }
ret		{ return RET; }
proc		{ return PROC; }
endproc		{ return ENDPROC; }
callk		{ return CALLK; }

nop		{ return NOP; }
abort		{ return ABORT; }
remove		{ return REMOVE; }
suspend		{ return SUSPEND; }
resume		{ return RESUME; }
exit   		{ return EXIT; }

setmaj 		{ return SETMAJ; }
setmin 		{ return SETMIN; }

log 		{ return LOG; }
arf		{ return STR; }
str		{ return STR; }
mrf		{ return MRF; }
b		{ return B; }
w		{ return W; }
d		{ return D; }

add		{ return ADD; }
mul		{ return MUL; }
and		{ return AND; }
or 		{ return OR; }
xor		{ return XOR; }
neg		{ return NEG; }
sub		{ return SUB; }
div		{ return DIV; }
idiv		{ return IDIV; }
pbl		{ return PBL; }
pbr		{ return PBR; }
pzl		{ return PZL; }
pzr		{ return PZR; }
xchg		{ return XCHG; }
rol		{ return ROL; }
ror             { return ROR; }
shl		{ return SHL; }
shr		{ return SHR; }
dup		{ return DUP; }
ros		{ return ROS; }

vfa		{ return VFYR; }
vfyr		{ return VFYR; }
vfyrw		{ return VFYRW; }

push		{ return PUSH; }
pop		{ return POP; }
bif		{ return BIF; }
wif		{ return WIF; }
dif		{ return DIF; }
qif		{ return QIF; }
mem		{ return MEM; }
u8		{ return U8; }
u16		{ return U16; }
u32		{ return U32; }
u64		{ return U64; }
iob		{ return IOB; }
iow		{ return IOW; }
iod		{ return IOD; }
pid		{ return PID; }
procid		{ return PROCID; }
task		{ return TASK; }
r		{ return R; }
u 		{ return U; }

sx		{ return SX; }
ux		{ return UX; }
rx		{ return RX; }
excpt_mask	{ return EX_MASK; }
lp		{ return LP; }
plp		{ return PLP; }
excpt_log	{ return EX_LOGMAX; }
st		{ return ST; }
purge		{ return PURGE; }
trace		{ return TRACE; }
pv		{ return PV; }
autostacktrace	{ return AUTOSTACKTRACE; }

sbp		{ return SBP; }
tsp		{ return TSP; }
stp		{ return STP; }
copy		{ return COPY; }
save		{ return SAVE; }
restore		{ return RESTORE; }

cs		{ return CS; }
ds		{ return DS; }
es		{ return ES; }
fs		{ return FS; }
gs		{ return GS; }
ss		{ return SS; }
eax		{ return EAX; }
ebx		{ return EBX; }
ecx		{ return ECX; }
edx		{ return EDX; }
edi		{ return EDI; }
esi		{ return ESI; }
eflags		{ return EFLAGS; }
eip		{ return EIP; }
esp		{ return ESP; }
ebp		{ return EBP; }
tr 		{ return TR; }
ldtr		{ return LDTR; }
gdtr		{ return GDTR; }
idtr		{ return IDTR; }
cr0		{ return CR0; }
cr1		{ return CR1; }
cr2		{ return CR2; }
cr3		{ return CR3; }
cr4		{ return CR4; }
dr0		{ return DR0; }
dr1		{ return DR1; }
dr2		{ return DR2; }
dr3		{ return DR3; }
dr6 		{ return DR6; }
dr7		{ return DR7; }
cpuid		{ return CPUID; }
msr		{ return MSR; }

fr0		{ return FR0; }
fr1		{ return FR1; }
fr2		{ return FR2; }
fr3		{ return FR3; }
fr4		{ return FR4; }
fr5		{ return FR5; }
fr6		{ return FR6; }
fr7		{ return FR7; }
fcw		{ return FCW; }
fsw		{ return FSW; }
ftw		{ return FTW; }
fip		{ return FIP; }
fcs		{ return FCS; }
fdp		{ return FDP; }
fds		{ return FDS; }

xmm0		{ return XMM0; }
xmm1		{ return XMM1; }
xmm2		{ return XMM2; }
xmm3		{ return XMM3; }
xmm4		{ return XMM4; }
xmm5		{ return XMM5; }
xmm6		{ return XMM6; }
xmm7		{ return XMM7; }
mxcsr		{ return MXCSR; }

move		{ return MOVE; }
lv		{ return LV; }
gv		{ return GV; }
inc		{ return INC; }
dec		{ return DEC; }

[0-9]+ 	|
-[0-9]+ 	|
0x[0-9a-f]+	{ rpnlval.ul = strtoul(rpntext, NULL, 0); return NUMBER; }

[a-zA-Z_][-a-zA-Z0-9_]*	{ rpnlval.string = strdup(rpntext);
			  return STRING;}

\"[^"\r\n]+["\n] { rpnlval.string = strip_quotes(rpntext);
		   return PATH;}

"//".*		{ /* comment */ ; }

#.*		{ /* ignore #file, #line etc */ ; }

[ \t\r]+	{ /* white space */ ; }

\n		{ rpnlineno++; }

.		{ return rpntext[0]; }

%%

